/* Generated from Java with JSweet 3.0.0 - http://www.jsweet.org */
var LambertW = /** @class */ (function () {
    function LambertW() {
    }
    LambertW.halley_iteration = function (x, w_initial, max_iters, result) {
        var w = w_initial;
        var i;
        for (i = 0; i < max_iters; i++) {
            {
                var tol = void 0;
                var e = Math.exp(w);
                var p = w + 1.0;
                var t = w * e - x;
                if (w > 0) {
                    t = (t / p) / e;
                }
                else {
                    t /= e * p - 0.5 * (p + 1.0) * t / p;
                }
                w -= t;
                tol = 10 * LambertW.GSL_DBL_EPSILON * Math.max(Math.abs(w), 1.0 / (Math.abs(p) * e));
                if (Math.abs(t) < tol) {
                    result.val = w;
                    result.err = 2.0 * tol;
                    return LambertW.GSL_RETURN.GSL_SUCCESS;
                }
            }
            ;
        }
        result.val = w;
        result.err = Math.abs(w);
        return LambertW.GSL_RETURN.GSL_EMAXITER;
    };
    LambertW.c_$LI$ = function () { if (LambertW.c == null) {
        LambertW.c = [-1.0, 2.331643981597124, -1.8121878856393634, 1.9366311144923598, -2.3535512018816145, 3.0668589010506317, -4.175335600258177, 5.858023729874774, -8.401032217523978, 12.25075350131446, -18.10069701247244, 27.029044799010563];
    } return LambertW.c; };
    LambertW.series_eval = function (r) {
        var t_8 = LambertW.c_$LI$()[8] + r * (LambertW.c_$LI$()[9] + r * (LambertW.c_$LI$()[10] + r * LambertW.c_$LI$()[11]));
        var t_5 = LambertW.c_$LI$()[5] + r * (LambertW.c_$LI$()[6] + r * (LambertW.c_$LI$()[7] + r * t_8));
        var t_1 = LambertW.c_$LI$()[1] + r * (LambertW.c_$LI$()[2] + r * (LambertW.c_$LI$()[3] + r * (LambertW.c_$LI$()[4] + r * t_5)));
        return LambertW.c_$LI$()[0] + r * t_1;
    };
    LambertW.gsl_sf_lambert_W0_e = function (x, result) {
        var one_over_E = 1.0 / LambertW.M_E;
        var q = x + one_over_E;
        if (x === 0.0) {
            result.val = 0.0;
            result.err = 0.0;
            return LambertW.GSL_RETURN.GSL_SUCCESS;
        }
        else if (q < 0.0) {
            result.val = -1.0;
            result.err = Math.sqrt(-q);
            return LambertW.GSL_RETURN.GSL_EDOM;
        }
        else if (q === 0.0) {
            result.val = -1.0;
            result.err = LambertW.GSL_DBL_EPSILON;
            return LambertW.GSL_RETURN.GSL_SUCCESS;
        }
        else if (q < 0.001) {
            var r = Math.sqrt(q);
            result.val = LambertW.series_eval(r);
            result.err = 2.0 * LambertW.GSL_DBL_EPSILON * Math.abs(result.val);
            return LambertW.GSL_RETURN.GSL_SUCCESS;
        }
        else {
            var MAX_ITERS = 10;
            var w = void 0;
            if (x < 1.0) {
                var p = Math.sqrt(2.0 * LambertW.M_E * q);
                w = -1.0 + p * (1.0 + p * (-1.0 / 3.0 + p * 11.0 / 72.0));
            }
            else {
                w = Math.log(x);
                if (x > 3.0)
                    w -= Math.log(w);
            }
            return LambertW.halley_iteration(x, w, MAX_ITERS, result);
        }
    };
    LambertW.gsl_sf_lambert_Wm1_e = function (x, result) {
        if (x > 0.0) {
            return LambertW.gsl_sf_lambert_W0_e(x, result);
        }
        else if (x === 0.0) {
            result.val = 0.0;
            result.err = 0.0;
            return LambertW.GSL_RETURN.GSL_SUCCESS;
        }
        else {
            var MAX_ITERS = 32;
            var one_over_E = 1.0 / LambertW.M_E;
            var q = x + one_over_E;
            var w = void 0;
            if (q < 0.0) {
                result.val = -1.0;
                result.err = Math.sqrt(-q);
                return LambertW.GSL_RETURN.GSL_EDOM;
            }
            if (x < -1.0E-6) {
                var r = -Math.sqrt(q);
                w = LambertW.series_eval(r);
                if (q < 0.003) {
                    result.val = w;
                    result.err = 5.0 * LambertW.GSL_DBL_EPSILON * Math.abs(w);
                    return LambertW.GSL_RETURN.GSL_SUCCESS;
                }
            }
            else {
                var L_1 = Math.log(-x);
                var L_2 = Math.log(-L_1);
                w = L_1 - L_2 + L_2 / L_1;
            }
            return LambertW.halley_iteration(x, w, MAX_ITERS, result);
        }
    };
    LambertW.branch0 = function (x) {
        var result = new LambertW.gsl_sf_result();
        var res = LambertW.gsl_sf_lambert_W0_e(x, result);
        if (res === LambertW.GSL_RETURN.GSL_EMAXITER) {
            throw Object.defineProperty(new Error("Too many iterations"), '__classes', { configurable: true, value: ['java.lang.Throwable', 'java.lang.Object', 'java.lang.RuntimeException', 'java.lang.Exception'] });
        }
        return result.val;
    };
    LambertW.branchNeg1 = function (x) {
        var result = new LambertW.gsl_sf_result();
        var res = LambertW.gsl_sf_lambert_Wm1_e(x, result);
        if (res === LambertW.GSL_RETURN.GSL_EMAXITER) {
            throw Object.defineProperty(new Error("Too many iterations"), '__classes', { configurable: true, value: ['java.lang.Throwable', 'java.lang.Object', 'java.lang.RuntimeException', 'java.lang.Exception'] });
        }
        return result.val;
    };
    LambertW.M_E = 2.718281828459045;
    LambertW.GSL_DBL_EPSILON = 2.220446049250313E-16;
    return LambertW;
}());
LambertW["__class"] = "LambertW";
(function (LambertW) {
    var gsl_sf_result = /** @class */ (function () {
        function gsl_sf_result() {
            if (this.val === undefined) {
                this.val = 0;
            }
            if (this.err === undefined) {
                this.err = 0;
            }
            this.val = this.err = 0;
        }
        return gsl_sf_result;
    }());
    LambertW.gsl_sf_result = gsl_sf_result;
    gsl_sf_result["__class"] = "LambertW.gsl_sf_result";
    var GSL_RETURN;
    (function (GSL_RETURN) {
        GSL_RETURN[GSL_RETURN["GSL_SUCCESS"] = 0] = "GSL_SUCCESS";
        GSL_RETURN[GSL_RETURN["GSL_EMAXITER"] = 1] = "GSL_EMAXITER";
        GSL_RETURN[GSL_RETURN["GSL_EDOM"] = 2] = "GSL_EDOM";
    })(GSL_RETURN = LambertW.GSL_RETURN || (LambertW.GSL_RETURN = {}));
})(LambertW || (LambertW = {}));
