//STEADY STATE POPULATION FOR 55 DAYS 
//initial egg count
function beepop(E0,SE,SL,SP,SFP,S,SF,SH){

//calculating number of eggs
const NE=Array.from({length:56},(_,i)=>i); //total number of days in bee life cycle
let E=[];
for(let i=0; i < NE.length; i++){
    E[i]=E0*((1-(SE**NE[i]))/(1-SE));    
}
//calculating number of larvae
const NL=Array.from({length:56},(_,i)=>i+5);
let L=[];
for(let i=0; i < NE.length; i++){
    L[i]=E0*(SE**NE[i])*((1-(SL**NL[i]))/(1-SL));
}

//calculating number of pupae
const NP=Array.from({length:56},(_,i)=>i+12); //array from 12:67
let P=[];
for(let i=0; i < NE.length; i++){
    P[i]=E0*(SE**NE[i])*(SL**NL[i])*((1-(SP**NP[i]))/(1-SP));
}

//calculating number of hive bees
const NH=Array.from({length:56},(_,i)=>i+21); //array from 21:76
let H=[];
for(let i=0; i < NE.length; i++){
    H[i]=E0*(SE**NE[i])*(SL**NL[i])*(SP**NP[i])*((1-(SH**NH[i]))/(1-SH));
}


//calculating number of foragers
const NF=Array.from({length:56},(_,i)=>i+21); //array from 21:76
let F0=[];
for(let i=0; i<NE.length;i++){
    F0[i]=E0*(SE**NE[i])*(SL**NL[i])*(SP**NP[i])*(SH**NH[i])*((1-(SF**NF[i]))/(1-SF));
}

//CALCULATING THE FOOD SUPPLY VERSUS DEMAND : NORMAL CONDITIONS

//C is daily consumption rates in grams for different bee class
let p=0.1;  //p grams of Food (Nectar + pollen) per day
let CL=0.018;
let CH=0.007;
let CF=0.007;
//S = stored Food

let supply=[];
for(let i=0;i<NE.length;i++){
    supply[i]=F0[i]*p+S;
}

let consumption=[];
for(let i=0;i<NE.length;i++){
    consumption[i]=L[i]*CL+H[i]*CH+F0[i]*CF;
}   


//CALCULATING THE FOOD SUPPLY VERSUS DEMAND : PESTICIDE CONDITIONS
let F0P=[];
for(let i=0; i<NF.length;i++){
    F0P[i]=E0*(SE**NE[i])*(SL**NL[i])*(SP**NP[i])*(SH**NH[i])*((1-(SFP**NF[i]))/(1-SFP));
}


let supplyP=[];
for(let i=0;i<NE.length;i++){
    supplyP[i]=F0P[i]*p+S;
}

let consumptionP=[];
for(let i=0;i<NE.length;i++){
    consumptionP[i]=L[i]*CL+H[i]*CH+F0P[i]*CF;
}
return [supply,consumption,supplyP,consumptionP];
}
